import greenfoot.GreenfootImage;

import java.awt.Color;
import java.awt.Font;

/**
 * representation of a conservation bonus object
 * 
 * @author Dietrich Boles (University of Oldenburg, Germany)
 * @version 01.12.2009
 */
public class ConservationBonus extends Bonus {
	private int counter;

	public ConservationBonus(int bonus) {
		super(bonus);
		this.setImage("bonus.png");
		GreenfootImage image = this.getImage();
		image.setTransparency(150);
		image.setFont(new Font("Monospaced", Font.BOLD, 18));
		image.setColor(new Color(223, 244, 12));
		image.drawString("" + bonus, 158, 95);
		image.setFont(new Font("Monospaced", Font.BOLD, 12));
		image.drawString("Conservation Bonus", 20, 113);

		this.counter = 0;
	}

	public void act() {
		this.counter++;
		if (this.counter == 40) {
			this.getWorld().removeObject(this);
		}
	}
}
