import greenfoot.GreenfootImage;

/**
 * representation of two items on the same cell
 * 
 * @author Dietrich Boles (University of Oldenburg, Germany)
 * @version 01.12.2009
 */
public abstract class DoubleItem extends Item {

	protected Item bottom, top;

	public DoubleItem(Item bottom, Item top) {
		super();
		this.bottom = bottom;
		this.top = top;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see Item#draw(greenfoot.GreenfootImage, int, int, int)
	 */
	@Override
	public void draw(GreenfootImage img, int c, int r, int cellSize) {
		this.bottom.draw(img, c, r, cellSize);
		this.top.draw(img, c, r, cellSize);
	}

}
