import greenfoot.GreenfootImage;

/**
 * Representation of an extinguisher. Can be used to extinguish fire.
 * 
 * @author Dietrich Boles (University of Oldenburg, Germany)
 * @version 01.12.2009
 */
public class Extinguisher extends Item {

	// shared by all objects
	private static GreenfootImage img = new GreenfootImage("extinguisher.png");

	public Extinguisher() {
		super(Item.FIRE_EXTINGUISHER);
		this.setImage(Extinguisher.img);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see Item#isAccessible(WasteWorld, int, int)
	 */
	@Override
	public boolean isAccessible(WasteWorld world, int col, int row) {
		return true;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see Item#draw(greenfoot.GreenfootImage, int, int, int)
	 */
	@Override
	public void draw(GreenfootImage img, int c, int r, int cellSize) {
		img.drawImage(this.getImage(), (c + 1) * cellSize, (r + 1) * cellSize);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see Item#handleCollisionAfterScrolling(WasteWorld, int, int)
	 */
	@Override
	public void handleCollisionAfterScrolling(WasteWorld world, int col, int row) {
		if (!Storage.getStorage().isFull()) {
			Sounds.pickup();
			Storage.getStorage().addItem(this); // put the extinguisher into the
			// storage
			world.removeItem(col, row);
		}
	}
}
