import greenfoot.GreenfootImage;

/**
 * representation of a ladder. A ladder can be used to pass pitfalls
 * 
 * @author Dietrich Boles (University of Oldenburg, Germany)
 * @version 01.12.2009
 */
public class Ladder extends Item {

	// shared by all objects
	private static GreenfootImage img = new GreenfootImage("ladder.png");

	public Ladder() {
		super(Item.PITFALL_LADDER);
		this.setImage(Ladder.img);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see Item#isAccessible(WasteWorld, int, int)
	 */
	@Override
	public boolean isAccessible(WasteWorld world, int col, int row) {
		return true;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see Item#draw(greenfoot.GreenfootImage, int, int, int)
	 */
	@Override
	public void draw(GreenfootImage img, int c, int r, int cellSize) {
		img.drawImage(this.getImage(), (c + 1) * cellSize, (r + 1) * cellSize);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see Item#handleCollisionAfterScrolling(WasteWorld, int, int)
	 */
	@Override
	public void handleCollisionAfterScrolling(WasteWorld world, int col, int row) {
		if (!Storage.getStorage().isFull()) {
			Sounds.pickup();
			Storage.getStorage().addItem(this); // add the ladder to the storage
			world.removeItem(col, row);
		}
	}
}
