import greenfoot.GreenfootImage;

/**
 * representation of level 1 (waste)
 * 
 * Task: Find, collect and dispose of the waste!
 * 
 * @author Dietrich Boles (University of Oldenburg, Germany)
 * @version 01.12.2009
 */
public class Level1 extends Level {

	public Level1() {
		super("level1.png", new SelectionItem(1, "level1selection.png"));
		this.selectionItem = new SelectionItem(1, "level1selection.png");
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see Level#createLevel(Item[][])
	 */
	@Override
	public void createLevel(Item[][] items) {
		this.numberOfWaste = 0;
		this.worldFilter = null; // no world filter
		this.cellFilter = null; // no cell filter

		// empty all cells
		for (int c = 0; c < items.length; c++) {
			for (int r = 0; r < items[c].length; r++) {
				items[c][r] = null;
			}
		}

		// place walls
		items[0][9] = new Wall();
		items[0][10] = new Wall();
		items[0][17] = new Wall();

		items[1][9] = new Wall();
		items[1][10] = new Wall();
		items[1][17] = new Wall();

		items[2][0] = new Wall();
		items[2][1] = new Wall();
		items[2][2] = new Wall();
		items[2][6] = new Wall();
		items[2][13] = new Wall();
		items[2][17] = new Wall();
		items[2][21] = new Wall();

		items[3][2] = new Wall();
		items[3][6] = new Wall();
		items[3][13] = new Wall();
		items[3][17] = new Wall();
		items[3][21] = new Wall();

		items[4][2] = new Wall();
		items[4][6] = new Wall();
		items[4][12] = new Wall();
		items[4][13] = new Wall();
		items[4][14] = new Wall();
		items[4][17] = new Wall();

		items[5][2] = new Wall();
		items[5][3] = new Wall();
		items[5][6] = new Wall();
		items[5][17] = new Wall();

		items[6][9] = new Wall();
		items[6][17] = new Wall();
		items[6][23] = new Wall();
		items[6][24] = new Wall();

		items[7][9] = new Wall();
		items[7][17] = new Wall();
		items[7][18] = new Wall();
		items[7][19] = new Wall();
		items[7][20] = new Wall();
		items[7][23] = new Wall();
		items[7][24] = new Wall();

		items[9][4] = new Wall();
		items[9][5] = new Wall();
		items[9][21] = new Wall();
		items[9][22] = new Wall();

		items[10][4] = new Wall();
		items[10][9] = new Wall();
		items[10][10] = new Wall();
		items[10][11] = new Wall();
		items[10][12] = new Wall();
		items[10][13] = new Wall();
		items[10][14] = new Wall();
		items[10][15] = new Wall();
		items[10][16] = new Wall();

		items[11][0] = new Wall();
		items[11][1] = new Wall();
		items[11][2] = new Wall();
		items[11][3] = new Wall();
		items[11][4] = new Wall();
		items[11][9] = new Wall();
		items[11][16] = new Wall();

		items[12][0] = new Wall();
		items[12][1] = new Wall();
		items[12][9] = new Wall();
		items[12][16] = new Wall();
		items[12][22] = new Wall();
		items[12][23] = new Wall();
		items[12][24] = new Wall();

		items[13][9] = new Wall();
		items[13][12] = new Wall();
		items[13][13] = new Wall();
		items[13][16] = new Wall();
		items[13][17] = new Wall();

		items[14][9] = new Wall();
		items[14][10] = new Wall();
		items[14][12] = new Wall();
		items[14][13] = new Wall();

		items[15][9] = new Wall();
		items[15][22] = new Wall();
		items[15][23] = new Wall();

		items[16][4] = new Wall();
		items[16][5] = new Wall();
		items[16][9] = new Wall();
		items[16][16] = new Wall();
		items[16][22] = new Wall();
		items[16][23] = new Wall();

		items[17][4] = new Wall();
		items[17][5] = new Wall();
		items[17][9] = new Wall();
		items[17][10] = new Wall();
		items[17][11] = new Wall();
		items[17][12] = new Wall();
		items[17][13] = new Wall();
		items[17][14] = new Wall();
		items[17][15] = new Wall();
		items[17][16] = new Wall();

		items[20][2] = new Wall();
		items[20][19] = new Wall();

		items[21][2] = new Wall();
		items[21][11] = new Wall();
		items[21][19] = new Wall();

		items[22][2] = new Wall();
		items[22][11] = new Wall();
		items[22][15] = new Wall();
		items[22][18] = new Wall();
		items[22][23] = new Wall();
		items[22][24] = new Wall();

		items[23][2] = new Wall();
		items[23][11] = new Wall();
		items[23][12] = new Wall();
		items[23][13] = new Wall();
		items[23][15] = new Wall();
		items[23][17] = new Wall();
		items[23][23] = new Wall();
		items[23][24] = new Wall();

		items[24][2] = new Wall();
		items[24][3] = new Wall();
		items[24][4] = new Wall();
		items[24][5] = new Wall();
		items[24][6] = new Wall();
		items[24][7] = new Wall();
		items[24][13] = new Wall();
		items[24][17] = new Wall();

		items[25][7] = new Wall();
		items[25][13] = new Wall();
		items[25][17] = new Wall();
		items[25][18] = new Wall();
		items[25][21] = new Wall();

		items[26][7] = new Wall();
		items[26][13] = new Wall();
		items[26][14] = new Wall();
		items[26][18] = new Wall();

		items[27][7] = new Wall();
		items[27][14] = new Wall();
		items[27][18] = new Wall();

		items[28][0] = new Wall();
		items[28][1] = new Wall();
		items[28][2] = new Wall();
		items[28][3] = new Wall();
		items[28][4] = new Wall();
		items[28][5] = new Wall();
		items[28][6] = new Wall();
		items[28][7] = new Wall();
		items[28][14] = new Wall();
		items[28][15] = new Wall();
		items[28][16] = new Wall();
		items[28][17] = new Wall();
		items[28][18] = new Wall();
		items[28][22] = new Wall();

		items[29][22] = new Wall();

		items[30][10] = new Wall();
		items[30][22] = new Wall();
		items[30][23] = new Wall();
		items[30][24] = new Wall();

		items[31][9] = new Wall();
		items[31][10] = new Wall();
		items[31][11] = new Wall();
		items[31][12] = new Wall();
		items[31][13] = new Wall();
		items[31][14] = new Wall();
		items[31][18] = new Wall();
		items[31][22] = new Wall();

		items[32][3] = new Wall();
		items[32][9] = new Wall();
		items[32][10] = new Wall();
		items[32][14] = new Wall();
		items[32][18] = new Wall();
		items[32][22] = new Wall();

		items[33][3] = new Wall();
		items[33][9] = new Wall();
		items[33][14] = new Wall();

		items[34][3] = new Wall();
		items[34][14] = new Wall();

		// place trees
		items[3][18] = new Tree();
		items[4][3] = new Tree();
		items[4][18] = new Tree();
		items[5][18] = new Tree();
		items[6][18] = new Tree();
		items[27][0] = new Tree();
		items[27][15] = new Tree();
		items[34][4] = new Tree();

		// place sign
		items[14][11] = new NoPassage();

		// place dustbins
		items[22][3] = new DustbinPaper();
		items[34][15] = new DustbinMetal();
		items[2][22] = new DustbinGlass();
		items[16][10] = new DustbinRest();
		items[5][0] = new DustbinBio();

		// place waste
		for (int i = 0; i < 4; i++) {
			Position pos = this.getFreeCell(items);
			items[pos.getCol()][pos.getRow()] = new WastePaper();
			this.numberOfWaste++;
		}

		for (int i = 0; i < 4; i++) {
			Position pos = this.getFreeCell(items);
			items[pos.getCol()][pos.getRow()] = new WasteMetal();
			this.numberOfWaste++;
		}

		for (int i = 0; i < 4; i++) {
			Position pos = this.getFreeCell(items);
			items[pos.getCol()][pos.getRow()] = new WasteGlass();
			this.numberOfWaste++;
		}

		for (int i = 0; i < 4; i++) {
			Position pos = this.getFreeCell(items);
			items[pos.getCol()][pos.getRow()] = new WasteRest();
			this.numberOfWaste++;
		}

		for (int i = 0; i < 4; i++) {
			Position pos = this.getFreeCell(items);
			items[pos.getCol()][pos.getRow()] = new WasteBio();
			this.numberOfWaste++;
		}

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see Level#getSeconds()
	 */
	@Override
	public int getSeconds() {
		return 160;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see Level#drawHelp(greenfoot.GreenfootImage)
	 */
	@Override
	public void drawHelp(GreenfootImage image) {
		image.drawString("Level 1 (waste): ", 20, 50);
		image.drawString("Task: Find, collect and dispose of the waste!", 20,
				100);
		image.drawString("Hint: Regard the type of the waste!", 20, 150);

	}

}
