import greenfoot.Greenfoot;
import greenfoot.GreenfootImage;

/**
 * representation of level 2 (more and more waste)
 * 
 * Task: Find, collect and dispose of the waste!
 * 
 * Additional task: Find the baddie who is polluting the environment!
 * 
 * Notice: This level contains one-way signs
 * 
 * @author Dietrich Boles (University of Oldenburg, Germany)
 * @version 01.12.2009
 */
public class Level2 extends Level {

	public Level2() {
		super("level2.png", new SelectionItem(2, "level2selection.png"));
		this.selectionItem = new SelectionItem(2, "level2selection.png");
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see Level#createLevel(Item[][])
	 */
	@Override
	public void createLevel(Item[][] items) {
		this.numberOfWaste = 0;
		this.worldFilter = null; // no world filter
		this.cellFilter = null; // no cell filter

		// empty all cells
		for (int c = 0; c < items.length; c++) {
			for (int r = 0; r < items[c].length; r++) {
				items[c][r] = null;
			}
		}

		// place walls
		items[0][13] = new Wall();
		items[0][21] = new Wall();

		items[1][23] = new Wall();

		items[2][5] = new Wall();
		items[2][6] = new Wall();
		items[2][7] = new Wall();
		items[2][8] = new Wall();
		items[2][9] = new Wall();
		items[2][13] = new Wall();
		items[2][16] = new Wall();
		items[2][21] = new Wall();

		items[3][1] = new Wall();
		items[3][5] = new Wall();
		items[3][6] = new Wall();
		items[3][16] = new Wall();
		items[3][23] = new Wall();

		items[4][1] = new Wall();
		items[4][13] = new Wall();
		items[4][21] = new Wall();

		items[5][1] = new Wall();
		items[5][23] = new Wall();

		items[6][1] = new Wall();
		items[6][2] = new Wall();
		items[6][3] = new Wall();
		items[6][4] = new Wall();
		items[6][5] = new Wall();
		items[6][6] = new Wall();
		items[6][7] = new Wall();
		items[6][13] = new Wall();
		items[6][15] = new Wall();
		items[6][17] = new Wall();
		items[6][19] = new Wall();
		items[6][21] = new Wall();

		items[7][7] = new Wall();

		items[8][7] = new Wall();
		items[8][10] = new Wall();

		items[9][7] = new Wall();
		items[9][10] = new Wall();
		items[9][11] = new Wall();
		items[9][15] = new Wall();
		items[9][23] = new Wall();
		items[9][24] = new Wall();

		items[10][5] = new Wall();
		items[10][6] = new Wall();
		items[10][7] = new Wall();
		items[10][10] = new Wall();
		items[10][11] = new Wall();
		items[10][15] = new Wall();
		items[10][16] = new Wall();
		items[10][23] = new Wall();

		items[11][7] = new Wall();
		items[11][15] = new Wall();
		items[11][16] = new Wall();
		items[11][23] = new Wall();

		items[12][2] = new Wall();
		items[12][7] = new Wall();
		items[12][23] = new Wall();

		items[13][2] = new Wall();
		items[13][7] = new Wall();
		items[13][23] = new Wall();

		items[14][6] = new Wall();
		items[14][7] = new Wall();
		items[14][10] = new Wall();
		items[14][11] = new Wall();
		items[14][12] = new Wall();
		items[14][14] = new Wall();
		items[14][15] = new Wall();
		items[14][16] = new Wall();
		items[14][18] = new Wall();
		items[14][19] = new Wall();
		items[14][20] = new Wall();

		items[15][6] = new Wall();
		items[15][10] = new Wall();
		items[15][20] = new Wall();

		items[16][6] = new Wall();
		items[16][10] = new Wall();
		items[16][12] = new Wall();
		items[16][13] = new Wall();
		items[16][14] = new Wall();
		items[16][15] = new Wall();
		items[16][16] = new Wall();
		items[16][17] = new Wall();
		items[16][18] = new Wall();
		items[16][20] = new Wall();

		items[17][1] = new Wall();
		items[17][2] = new Wall();
		items[17][3] = new Wall();
		items[17][4] = new Wall();
		items[17][5] = new Wall();
		items[17][6] = new Wall();
		items[17][10] = new Wall();
		items[17][12] = new Wall();
		items[17][18] = new Wall();
		items[17][20] = new Wall();

		items[18][2] = new Wall();
		items[18][9] = new Wall();
		items[18][12] = new Wall();
		items[18][14] = new Wall();
		items[18][15] = new Wall();
		items[18][16] = new Wall();
		items[18][18] = new Wall();

		items[19][2] = new Wall();
		items[19][9] = new Wall();
		items[19][12] = new Wall();
		items[19][16] = new Wall();
		items[19][18] = new Wall();

		items[20][2] = new Wall();
		items[20][6] = new Wall();
		items[20][10] = new Wall();
		items[20][12] = new Wall();
		items[20][13] = new Wall();
		items[20][15] = new Wall();
		items[20][16] = new Wall();
		items[20][18] = new Wall();

		items[21][6] = new Wall();
		items[21][10] = new Wall();
		items[21][18] = new Wall();
		items[21][23] = new Wall();
		items[21][24] = new Wall();

		items[22][10] = new Wall();
		items[22][11] = new Wall();
		items[22][12] = new Wall();
		items[22][13] = new Wall();
		items[22][14] = new Wall();
		items[22][15] = new Wall();
		items[22][16] = new Wall();
		items[22][17] = new Wall();
		items[22][18] = new Wall();
		items[22][21] = new Wall();
		items[22][22] = new Wall();
		items[22][23] = new Wall();

		items[23][20] = new Wall();
		items[23][21] = new Wall();

		items[24][1] = new Wall();
		items[24][2] = new Wall();
		items[24][3] = new Wall();
		items[24][4] = new Wall();
		items[24][5] = new Wall();
		items[24][6] = new Wall();
		items[24][20] = new Wall();
		items[24][23] = new Wall();
		items[24][24] = new Wall();

		items[25][5] = new Wall();
		items[25][13] = new Wall();
		items[25][18] = new Wall();
		items[25][19] = new Wall();
		items[25][22] = new Wall();
		items[25][23] = new Wall();

		items[26][5] = new Wall();
		items[26][6] = new Wall();
		items[26][7] = new Wall();
		items[26][8] = new Wall();
		items[26][13] = new Wall();
		items[26][18] = new Wall();
		items[26][21] = new Wall();
		items[26][22] = new Wall();

		items[27][2] = new Wall();
		items[27][8] = new Wall();
		items[27][17] = new Wall();
		items[27][20] = new Wall();
		items[27][21] = new Wall();

		items[28][2] = new Wall();
		items[28][8] = new Wall();
		items[28][9] = new Wall();
		items[28][10] = new Wall();
		items[28][11] = new Wall();
		items[28][15] = new Wall();
		items[28][16] = new Wall();
		items[28][19] = new Wall();
		items[28][20] = new Wall();

		items[29][2] = new Wall();
		items[29][5] = new Wall();
		items[29][11] = new Wall();
		items[29][18] = new Wall();
		items[29][19] = new Wall();
		items[29][22] = new Wall();

		items[30][5] = new Wall();
		items[30][11] = new Wall();
		items[30][17] = new Wall();
		items[30][18] = new Wall();
		items[30][22] = new Wall();

		items[31][5] = new Wall();
		items[31][8] = new Wall();
		items[31][11] = new Wall();

		items[32][0] = new Wall();
		items[32][1] = new Wall();
		items[32][8] = new Wall();
		items[32][14] = new Wall();
		items[32][15] = new Wall();
		items[32][16] = new Wall();

		items[33][14] = new Wall();
		items[33][20] = new Wall();

		items[34][14] = new Wall();
		items[34][20] = new Wall();

		// place trees
		items[2][17] = new Tree();
		items[2][22] = new Tree();
		items[3][17] = new Tree();
		items[9][12] = new Tree();
		items[10][12] = new Tree();
		items[14][13] = new Tree();
		items[14][17] = new Tree();
		items[18][10] = new Tree();
		items[19][10] = new Tree();
		items[19][19] = new Tree();
		items[20][3] = new Tree();
		items[20][14] = new Tree();
		items[20][19] = new Tree();
		items[28][3] = new Tree();
		items[29][3] = new Tree();
		items[30][23] = new Tree();

		// place signs

		items[6][0] = new OneWay();
		items[17][0] = new OneWay();

		// place dustbins
		items[34][21] = new DustbinPaper();
		items[5][2] = new DustbinMetal();
		items[6][20] = new DustbinMetal();
		items[12][3] = new DustbinGlass();
		items[27][3] = new DustbinRest();
		items[4][22] = new DustbinBio();
		items[18][3] = new DustbinBio();

		items[19][15] = new WasteBio();
		this.numberOfWaste++;
		items[22][24] = new WasteGlass();
		this.numberOfWaste++;

		// place a baddie you is polluting the environment
		int r = Greenfoot.getRandomNumber(3);
		switch (r) {
		case 0:
			items[33][23] = new Baddie(33, 23, Baddie.LEFT, WastePaper.class,
					WasteMetal.class, WasteGlass.class, WasteRest.class,
					WasteBio.class);
			break;
		case 1:
			items[20][22] = new Baddie(20, 22, Baddie.LEFT, WastePaper.class,
					WasteMetal.class, WasteGlass.class, WasteRest.class,
					WasteBio.class);
			break;
		default:
			items[13][8] = new Baddie(13, 8, Baddie.RIGHT, WastePaper.class,
					WasteMetal.class, WasteGlass.class, WasteRest.class,
					WasteBio.class);
			break;
		}

		// place waste

		for (int i = 0; i < 2; i++) {
			Position pos = this.getFreeCell(items);
			items[pos.getCol()][pos.getRow()] = new WastePaper();
			this.numberOfWaste++;
		}

		for (int i = 0; i < 3; i++) {
			Position pos = this.getFreeCell(items);
			items[pos.getCol()][pos.getRow()] = new WasteMetal();
			this.numberOfWaste++;
		}

		for (int i = 0; i < 2; i++) {
			Position pos = this.getFreeCell(items);
			items[pos.getCol()][pos.getRow()] = new WasteGlass();
			this.numberOfWaste++;
		}

		for (int i = 0; i < 2; i++) {
			Position pos = this.getFreeCell(items);
			items[pos.getCol()][pos.getRow()] = new WasteRest();
			this.numberOfWaste++;
		}

		for (int i = 0; i < 2; i++) {
			Position pos = this.getFreeCell(items);
			items[pos.getCol()][pos.getRow()] = new WasteBio();
			this.numberOfWaste++;
		}

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see Level#getSeconds()
	 */
	@Override
	public int getSeconds() {
		return 180;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see Level#drawHelp(greenfoot.GreenfootImage)
	 */
	@Override
	public void drawHelp(GreenfootImage image) {
		image.drawString("Level 2 (more and more waste): ", 20, 50);
		image.drawString("Task: Find, collect and dispose of the waste!", 20,
				100);
		image.drawString("Additional task:", 20, 150);
		image.drawString("Find the baddie who is polluting the environment!",
				20, 200);

	}

}
