import greenfoot.GreenfootImage;

/**
 * representation of level 3 (waste and light)
 * 
 * Task: Find, collect and dispose of the waste!
 * 
 * Additional task: The street lamps are wasting energy needlessly! Switch the
 * street lamps off!
 * 
 * Notice: This level contains one-way signs, traffic-lights and a world filter
 * 
 * @author Dietrich Boles (University of Oldenburg, Germany)
 * @version 01.12.2009
 */
public class Level3 extends Level {

	public Level3() {
		super("level3.png", new SelectionItem(3, "level3selection.png"));
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see Level#createLevel(Item[][])
	 */
	@Override
	public void createLevel(Item[][] items) {
		this.numberOfWaste = 0;
		this.cellFilter = null; // no cell filter

		// empty all cells
		for (int c = 0; c < items.length; c++) {
			for (int r = 0; r < items[c].length; r++) {
				items[c][r] = null;
			}
		}

		// place walls
		items[0][5] = new Wall();
		items[0][18] = new Wall();
		items[0][20] = new Wall();

		items[1][5] = new Wall();
		items[1][18] = new Wall();

		items[2][5] = new Wall();
		items[2][9] = new Wall();
		items[2][10] = new Wall();
		items[2][11] = new Wall();
		items[2][12] = new Wall();
		items[2][18] = new Wall();
		items[2][20] = new Wall();

		items[3][5] = new Wall();
		items[3][6] = new Wall();
		items[3][7] = new Wall();
		items[3][8] = new Wall();
		items[3][9] = new Wall();
		items[3][12] = new Wall();
		items[3][18] = new Wall();
		items[3][20] = new Wall();

		items[4][2] = new Wall();
		items[4][5] = new Wall();
		items[4][12] = new Wall();
		items[4][20] = new Wall();

		items[5][2] = new Wall();
		items[5][12] = new Wall();
		items[5][19] = new Wall();
		items[5][20] = new Wall();

		items[6][2] = new Wall();
		items[6][10] = new Wall();
		items[6][12] = new Wall();
		items[6][19] = new Wall();
		items[6][20] = new Wall();

		items[7][2] = new Wall();
		items[7][10] = new Wall();
		items[7][12] = new Wall();
		items[7][14] = new Wall();
		items[7][18] = new Wall();
		items[7][22] = new Wall();
		items[7][23] = new Wall();
		items[7][24] = new Wall();

		items[8][2] = new Wall();
		items[8][3] = new Wall();
		items[8][4] = new Wall();
		items[8][12] = new Wall();
		items[8][14] = new Wall();
		items[8][18] = new Wall();
		items[8][19] = new Wall();
		items[8][20] = new Wall();
		items[8][21] = new Wall();
		items[8][22] = new Wall();

		items[9][2] = new Wall();
		items[9][12] = new Wall();
		items[9][14] = new Wall();

		items[10][7] = new Wall();
		items[10][8] = new Wall();
		items[10][9] = new Wall();
		items[10][10] = new Wall();
		items[10][12] = new Wall();

		items[11][7] = new Wall();
		items[11][21] = new Wall();

		items[12][7] = new Wall();
		items[12][14] = new Wall();
		items[12][15] = new Wall();
		items[12][16] = new Wall();

		items[13][7] = new Wall();
		items[13][8] = new Wall();
		items[13][9] = new Wall();
		items[13][10] = new Wall();
		items[13][11] = new Wall();
		items[13][12] = new Wall();
		items[13][13] = new Wall();
		items[13][14] = new Wall();
		items[13][16] = new Wall();
		items[13][17] = new Wall();
		items[13][18] = new Wall();
		items[13][19] = new Wall();
		items[13][20] = new Wall();
		items[13][22] = new Wall();
		items[13][23] = new Wall();
		items[13][24] = new Wall();

		items[14][2] = new Wall();
		items[14][3] = new Wall();
		items[14][7] = new Wall();
		items[14][13] = new Wall();

		items[15][3] = new Wall();
		items[15][7] = new Wall();

		items[16][3] = new Wall();
		items[16][16] = new Wall();
		items[16][17] = new Wall();
		items[16][18] = new Wall();
		items[16][19] = new Wall();
		items[16][20] = new Wall();
		items[16][21] = new Wall();

		items[17][0] = new Wall();
		items[17][1] = new Wall();
		items[17][2] = new Wall();
		items[17][3] = new Wall();
		items[17][10] = new Wall();
		items[17][11] = new Wall();
		items[17][16] = new Wall();

		items[18][3] = new Wall();
		items[18][10] = new Wall();
		items[18][11] = new Wall();
		items[18][16] = new Wall();

		items[19][3] = new Wall();
		items[19][16] = new Wall();

		items[20][3] = new Wall();
		items[20][5] = new Wall();
		items[20][6] = new Wall();
		items[20][7] = new Wall();
		items[20][16] = new Wall();
		items[20][22] = new Wall();

		items[21][5] = new Wall();
		items[21][22] = new Wall();

		items[22][5] = new Wall();
		items[22][9] = new Wall();
		items[22][10] = new Wall();
		items[22][11] = new Wall();
		items[22][12] = new Wall();
		items[22][22] = new Wall();

		items[23][5] = new Wall();
		items[23][9] = new Wall();

		items[24][2] = new Wall();
		items[24][3] = new Wall();
		items[24][4] = new Wall();
		items[24][5] = new Wall();

		items[25][2] = new Wall();
		items[25][5] = new Wall();
		items[25][14] = new Wall();
		items[25][15] = new Wall();
		items[25][17] = new Wall();
		items[25][18] = new Wall();

		items[26][5] = new Wall();
		items[26][14] = new Wall();
		items[26][18] = new Wall();

		items[27][5] = new Wall();
		items[27][6] = new Wall();
		items[27][7] = new Wall();
		items[27][8] = new Wall();
		items[27][9] = new Wall();
		items[27][14] = new Wall();
		items[27][18] = new Wall();
		items[27][19] = new Wall();
		items[27][20] = new Wall();
		items[27][21] = new Wall();

		items[28][9] = new Wall();
		items[28][14] = new Wall();
		items[28][15] = new Wall();
		items[28][17] = new Wall();
		items[28][18] = new Wall();
		items[28][21] = new Wall();

		items[29][9] = new Wall();
		items[29][14] = new Wall();
		items[29][21] = new Wall();

		items[30][9] = new Wall();
		items[30][14] = new Wall();
		items[30][15] = new Wall();
		items[30][21] = new Wall();
		items[30][22] = new Wall();
		items[30][24] = new Wall();

		items[31][4] = new Wall();
		items[31][9] = new Wall();
		items[31][15] = new Wall();

		items[32][4] = new Wall();
		items[32][5] = new Wall();
		items[32][7] = new Wall();
		items[32][8] = new Wall();
		items[32][9] = new Wall();
		items[32][11] = new Wall();
		items[32][12] = new Wall();
		items[32][13] = new Wall();
		items[32][14] = new Wall();
		items[32][15] = new Wall();

		items[33][5] = new Wall();
		items[33][7] = new Wall();
		items[33][19] = new Wall();

		items[34][5] = new Wall();
		items[34][19] = new Wall();

		// place trees

		items[6][3] = new Tree();
		items[3][21] = new Tree();
		items[4][21] = new Tree();
		items[14][14] = new Tree();
		items[19][17] = new Tree();
		items[20][17] = new Tree();
		items[21][23] = new Tree();
		items[22][13] = new Tree();
		items[31][5] = new Tree();
		items[31][16] = new Tree();
		items[32][16] = new Tree();

		// place signs

		items[28][16] = new OneWay(true);
		items[30][23] = new OneWay(false);
		items[32][10] = new OneWay(false);
		items[33][6] = new OneWay(false);

		// place traffic lights

		items[2][19] = new TrafficLight();
		items[10][11] = new TrafficLight();
		items[13][21] = new TrafficLight();
		items[20][4] = new TrafficLight();
		items[25][16] = new TrafficLight();

		// place lamps

		items[4][6] = new Streetlamp();
		items[6][20] = new Streetlamp();
		items[12][8] = new Streetlamp();
		items[16][4] = new Streetlamp();
		items[25][3] = new Streetlamp();
		items[26][6] = new Streetlamp();
		items[22][23] = new Streetlamp();
		items[30][16] = new Streetlamp();
		items[29][22] = new Streetlamp();

		// assign a world filter to the level
		this.worldFilter = new LightFilter(9);

		// place dustbins
		items[18][17] = new DustbinPaper();
		items[11][22] = new DustbinMetal();
		items[5][21] = new DustbinGlass();
		items[33][8] = new DustbinGlass();
		items[9][15] = new DustbinRest();
		items[33][8] = new DustbinRest();
		items[34][20] = new DustbinBio();

		// place waste
		for (int i = 0; i < 4; i++) {
			Position pos = this.getFreeCell(items);
			items[pos.getCol()][pos.getRow()] = new WastePaper();
			this.numberOfWaste++;
		}

		for (int i = 0; i < 4; i++) {
			Position pos = this.getFreeCell(items);
			items[pos.getCol()][pos.getRow()] = new WasteMetal();
			this.numberOfWaste++;
		}

		for (int i = 0; i < 4; i++) {
			Position pos = this.getFreeCell(items);
			items[pos.getCol()][pos.getRow()] = new WasteGlass();
			this.numberOfWaste++;
		}

		for (int i = 0; i < 4; i++) {
			Position pos = this.getFreeCell(items);
			items[pos.getCol()][pos.getRow()] = new WasteRest();
			this.numberOfWaste++;
		}

		for (int i = 0; i < 4; i++) {
			Position pos = this.getFreeCell(items);
			items[pos.getCol()][pos.getRow()] = new WasteBio();
			this.numberOfWaste++;
		}

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see Level#getSeconds()
	 */
	@Override
	public int getSeconds() {
		return 220;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see Level#drawHelp(greenfoot.GreenfootImage)
	 */
	@Override
	public void drawHelp(GreenfootImage image) {
		image.drawString("Level 3 (waste and light): ", 20, 50);
		image.drawString("Task: Find, collect and dispose of the waste!", 20,
				100);
		image.drawString("Additional task:", 20, 150);
		image.drawString("The street lamps are wasting energy needlessly!", 20,
				200);
		image.drawString("Switch the street lamps off!", 20, 250);

	}

}
