import greenfoot.GreenfootImage;

/**
 * representation of level 4 (waste and smog)
 * 
 * Task: Find, collect and dispose of the waste!
 * 
 * Additional task: Cars are causing smog! Find the cars and replace them with
 * bikes!
 * 
 * Notice: This level contains one-way signs, pitfalls and a world filter
 * 
 * @author Dietrich Boles (University of Oldenburg, Germany)
 * @version 01.12.2009
 */
public class Level4 extends Level {

	public Level4() {
		super("level4.png", new SelectionItem(4, "level4selection.png"));
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see Level#createLevel(Item[][])
	 */
	@Override
	public void createLevel(Item[][] items) {
		this.numberOfWaste = 0;
		this.cellFilter = null; // no cell filter

		// empty all cells
		for (int c = 0; c < items.length; c++) {
			for (int r = 0; r < items[c].length; r++) {
				items[c][r] = null;
			}
		}

		// place walls

		items[0][15] = new Wall();

		items[1][9] = new Wall();
		items[1][10] = new Wall();
		items[1][15] = new Wall();

		items[2][2] = new Wall();
		items[2][3] = new Wall();
		items[2][9] = new Wall();
		items[2][10] = new Wall();
		items[2][12] = new Wall();
		items[2][13] = new Wall();
		items[2][15] = new Wall();
		items[2][20] = new Wall();
		items[2][22] = new Wall();

		items[3][2] = new Wall();
		items[3][3] = new Wall();
		items[3][12] = new Wall();
		items[3][13] = new Wall();
		items[3][20] = new Wall();
		items[3][22] = new Wall();

		items[4][12] = new Wall();
		items[4][17] = new Wall();
		items[4][20] = new Wall();
		items[4][22] = new Wall();

		items[5][12] = new Wall();
		items[5][20] = new Wall();
		items[5][22] = new Wall();

		items[6][6] = new Wall();
		items[6][7] = new Wall();
		items[6][12] = new Wall();
		items[6][17] = new Wall();
		items[6][20] = new Wall();
		items[6][22] = new Wall();

		items[7][6] = new Wall();
		items[7][7] = new Wall();
		items[7][12] = new Wall();
		items[7][13] = new Wall();
		items[7][20] = new Wall();
		items[7][22] = new Wall();

		items[8][13] = new Wall();
		items[8][20] = new Wall();
		items[8][22] = new Wall();

		items[9][13] = new Wall();
		items[9][17] = new Wall();
		items[9][20] = new Wall();
		items[9][22] = new Wall();

		items[10][13] = new Wall();
		items[10][17] = new Wall();
		items[10][20] = new Wall();
		items[10][22] = new Wall();

		items[11][0] = new Wall();
		items[11][2] = new Wall();
		items[11][7] = new Wall();
		items[11][8] = new Wall();
		items[11][13] = new Wall();
		items[11][20] = new Wall();
		items[11][22] = new Wall();

		items[12][2] = new Wall();
		items[12][7] = new Wall();
		items[12][8] = new Wall();
		items[12][13] = new Wall();

		items[13][2] = new Wall();
		items[13][3] = new Wall();
		items[13][4] = new Wall();
		items[13][13] = new Wall();
		items[13][17] = new Wall();
		items[13][18] = new Wall();

		items[14][4] = new Wall();
		items[14][12] = new Wall();
		items[14][13] = new Wall();

		items[15][4] = new Wall();
		items[15][5] = new Wall();
		items[15][6] = new Wall();
		items[15][12] = new Wall();
		items[15][13] = new Wall();
		items[15][20] = new Wall();
		items[15][21] = new Wall();
		items[15][22] = new Wall();

		items[16][6] = new Wall();
		items[16][13] = new Wall();
		items[16][16] = new Wall();
		items[16][17] = new Wall();

		items[17][6] = new Wall();
		items[17][7] = new Wall();
		items[17][8] = new Wall();
		items[17][13] = new Wall();

		items[18][8] = new Wall();
		items[18][13] = new Wall();

		items[19][2] = new Wall();
		items[19][4] = new Wall();
		items[19][5] = new Wall();
		items[19][8] = new Wall();
		items[19][13] = new Wall();
		items[19][20] = new Wall();
		items[19][21] = new Wall();
		items[19][22] = new Wall();

		items[20][1] = new Wall();
		items[20][3] = new Wall();
		items[20][5] = new Wall();
		items[20][8] = new Wall();
		items[20][13] = new Wall();
		items[20][16] = new Wall();
		items[20][17] = new Wall();
		items[20][21] = new Wall();

		items[21][8] = new Wall();
		items[21][13] = new Wall();
		items[21][17] = new Wall();
		items[21][21] = new Wall();

		items[22][6] = new Wall();
		items[22][7] = new Wall();
		items[22][8] = new Wall();
		items[22][13] = new Wall();

		items[23][6] = new Wall();
		items[23][13] = new Wall();

		items[24][4] = new Wall();
		items[24][5] = new Wall();
		items[24][6] = new Wall();
		items[24][13] = new Wall();

		items[25][4] = new Wall();
		items[25][13] = new Wall();

		items[26][2] = new Wall();
		items[26][3] = new Wall();
		items[26][4] = new Wall();
		items[26][13] = new Wall();
		items[26][17] = new Wall();
		items[26][21] = new Wall();
		items[26][22] = new Wall();
		items[26][23] = new Wall();
		items[26][24] = new Wall();

		items[27][2] = new Wall();
		items[27][7] = new Wall();
		items[27][13] = new Wall();
		items[27][17] = new Wall();
		items[27][21] = new Wall();

		items[28][2] = new Wall();
		items[28][3] = new Wall();
		items[28][7] = new Wall();
		items[28][13] = new Wall();
		items[28][21] = new Wall();

		items[29][3] = new Wall();
		items[29][4] = new Wall();
		items[29][13] = new Wall();
		items[29][21] = new Wall();

		items[30][4] = new Wall();
		items[30][5] = new Wall();
		items[30][13] = new Wall();
		items[30][14] = new Wall();
		items[30][21] = new Wall();

		items[31][5] = new Wall();
		items[31][13] = new Wall();
		items[31][14] = new Wall();
		items[31][21] = new Wall();

		items[32][5] = new Wall();
		items[32][13] = new Wall();
		items[32][22] = new Wall();

		items[33][2] = new Wall();
		items[33][5] = new Wall();
		items[33][13] = new Wall();
		items[33][15] = new Wall();
		items[33][20] = new Wall();
		items[33][22] = new Wall();

		items[34][2] = new Wall();
		items[34][5] = new Wall();
		items[34][15] = new Wall();
		items[34][20] = new Wall();

		// place trees

		items[2][4] = new Tree();
		items[3][4] = new Tree();
		items[6][8] = new Tree();
		items[7][8] = new Tree();
		items[11][9] = new Tree();
		items[12][9] = new Tree();
		items[1][11] = new Tree();
		items[2][11] = new Tree();
		items[19][14] = new Tree();
		items[20][14] = new Tree();
		items[21][14] = new Tree();
		items[22][14] = new Tree();
		items[23][14] = new Tree();
		items[24][14] = new Tree();
		items[26][14] = new Tree();
		items[27][14] = new Tree();
		items[30][15] = new Tree();
		items[31][15] = new Tree();
		items[31][6] = new Tree();
		items[32][6] = new Tree();

		// place signs

		items[2][14] = new OneWay(false);
		items[3][21] = new OneWay(false);
		items[33][14] = new OneWay(false);

		// place pitfalls

		items[1][24] = new Pitfall();
		items[11][21] = new Pitfall();
		items[33][1] = new Pitfall();
		items[33][24] = new Pitfall();

		// place bikes and cars

		items[7][3] = new Bike();
		items[6][21] = new Bike();
		items[30][2] = new Bike();
		items[28][24] = new Bike();
		items[26][11] = new Car(true);
		items[14][15] = new Car(false);
		items[21][19] = new Car(true);
		items[4][23] = new Car(false);

		// assign a world filter to the level
		this.worldFilter = new SmogFilter(4);

		// place dustbins

		items[30][22] = new DustbinPaper();
		items[16][7] = new DustbinPaper();
		items[31][22] = new DustbinMetal();
		items[26][5] = new DustbinMetal();
		items[28][22] = new DustbinGlass();
		items[10][21] = new DustbinGlass();
		items[27][22] = new DustbinRest();
		items[29][22] = new DustbinBio();
		items[28][8] = new DustbinBio();

		// place waste

		for (int i = 0; i < 4; i++) {
			Position pos = this.getFreeCell(items);
			items[pos.getCol()][pos.getRow()] = new WastePaper();
			this.numberOfWaste++;
		}

		for (int i = 0; i < 4; i++) {
			Position pos = this.getFreeCell(items);
			items[pos.getCol()][pos.getRow()] = new WasteMetal();
			this.numberOfWaste++;
		}

		for (int i = 0; i < 4; i++) {
			Position pos = this.getFreeCell(items);
			items[pos.getCol()][pos.getRow()] = new WasteGlass();
			this.numberOfWaste++;
		}

		for (int i = 0; i < 3; i++) {
			Position pos = this.getFreeCell(items);
			items[pos.getCol()][pos.getRow()] = new WasteRest();
			this.numberOfWaste++;
		}

		for (int i = 0; i < 4; i++) {
			Position pos = this.getFreeCell(items);
			items[pos.getCol()][pos.getRow()] = new WasteBio();
			this.numberOfWaste++;
		}

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see Level#getSeconds()
	 */
	@Override
	public int getSeconds() {
		return 220;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see Level#drawHelp(greenfoot.GreenfootImage)
	 */
	@Override
	public void drawHelp(GreenfootImage image) {
		image.drawString("Level 4 (waste and smog): ", 20, 50);
		image.drawString("Task: Find, collect and dispose of the waste!", 20,
				100);
		image.drawString("Additional task:", 20, 150);
		image.drawString("Cars are causing smog!", 20, 200);
		image.drawString("Find the cars and replace them with bikes!", 20, 250);
	}

}
