import greenfoot.GreenfootImage;

/**
 * representation of level 5 (waste and water)
 * 
 * Task: Find, collect and dispose of the waste!
 * 
 * Additional task: Somebody left the water running! Find the taps and turn them
 * off!
 * 
 * Notice: this level contains keys and doors and a cell filter
 * 
 * @author Dietrich Boles (University of Oldenburg, Germany)
 * @version 01.12.2009
 */
public class Level5 extends Level {

	public Level5() {
		super("level5.png", new SelectionItem(5, "level5selection.png"));
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see Level#createLevel(Item[][])
	 */
	@Override
	public void createLevel(Item[][] items) {
		this.numberOfWaste = 0;
		this.worldFilter = null; // no world filter

		// empty all cells
		for (int c = 0; c < items.length; c++) {
			for (int r = 0; r < items[c].length; r++) {
				items[c][r] = null;
			}
		}

		// place walls

		items[0][7] = new Wall();
		items[0][16] = new Wall();

		items[1][3] = new Wall();
		items[1][4] = new Wall();
		items[1][11] = new Wall();
		items[1][12] = new Wall();
		items[1][19] = new Wall();
		items[1][20] = new Wall();

		items[2][2] = new Wall();
		items[2][5] = new Wall();
		items[2][10] = new Wall();
		items[2][13] = new Wall();
		items[2][18] = new Wall();
		items[2][21] = new Wall();

		items[3][1] = new Wall();
		items[3][6] = new Wall();
		items[3][9] = new Wall();
		items[3][14] = new Wall();
		items[3][17] = new Wall();
		items[3][22] = new Wall();

		items[4][1] = new Wall();
		items[4][6] = new Wall();
		items[4][9] = new Wall();
		items[4][14] = new Wall();
		items[4][17] = new Wall();
		items[4][22] = new Wall();

		items[5][1] = new Wall();
		items[5][6] = new Wall();
		items[5][9] = new Wall();
		items[5][14] = new Wall();
		items[5][17] = new Wall();
		items[5][22] = new Wall();

		items[6][2] = new Wall();
		items[6][10] = new Wall();
		items[6][18] = new Wall();

		items[7][0] = new Wall();
		items[7][1] = new Wall();
		items[7][2] = new Wall();
		items[7][3] = new Wall();
		items[7][4] = new Wall();
		items[7][5] = new Wall();
		items[7][8] = new Wall();
		items[7][9] = new Wall();
		items[7][10] = new Wall();
		items[7][11] = new Wall();
		items[7][12] = new Wall();
		items[7][13] = new Wall();
		items[7][16] = new Wall();
		items[7][17] = new Wall();
		items[7][18] = new Wall();
		items[7][19] = new Wall();
		items[7][20] = new Wall();
		items[7][21] = new Wall();

		items[8][12] = new Wall();
		items[8][20] = new Wall();

		items[9][3] = new Wall();
		items[9][12] = new Wall();
		items[9][17] = new Wall();

		items[10][3] = new Wall();
		items[10][14] = new Wall();

		items[11][11] = new Wall();
		items[11][12] = new Wall();
		items[11][13] = new Wall();
		items[11][14] = new Wall();
		items[11][15] = new Wall();
		items[11][16] = new Wall();
		items[11][17] = new Wall();
		items[11][18] = new Wall();
		items[11][19] = new Wall();
		items[11][20] = new Wall();
		items[11][21] = new Wall();
		items[11][23] = new Wall();

		items[12][2] = new Wall();
		items[12][3] = new Wall();
		items[12][4] = new Wall();
		items[12][5] = new Wall();
		items[12][6] = new Wall();
		items[12][7] = new Wall();
		items[12][10] = new Wall();
		items[12][11] = new Wall();
		items[12][13] = new Wall();
		items[12][18] = new Wall();
		items[12][23] = new Wall();

		items[13][2] = new Wall();
		items[13][9] = new Wall();
		items[13][11] = new Wall();
		items[13][13] = new Wall();
		items[13][16] = new Wall();
		items[13][18] = new Wall();
		items[13][22] = new Wall();
		items[13][23] = new Wall();

		items[14][2] = new Wall();
		items[14][3] = new Wall();
		items[14][4] = new Wall();
		items[14][5] = new Wall();
		items[14][6] = new Wall();
		items[14][7] = new Wall();
		items[14][8] = new Wall();
		items[14][11] = new Wall();
		items[14][13] = new Wall();
		items[14][16] = new Wall();
		items[14][18] = new Wall();
		items[14][21] = new Wall();
		items[14][23] = new Wall();

		items[15][7] = new Wall();
		items[15][11] = new Wall();
		items[15][13] = new Wall();
		items[15][16] = new Wall();
		items[15][20] = new Wall();
		items[15][21] = new Wall();
		items[15][23] = new Wall();

		items[16][6] = new Wall();
		items[16][11] = new Wall();
		items[16][13] = new Wall();
		items[16][15] = new Wall();
		items[16][16] = new Wall();
		items[16][18] = new Wall();
		items[16][23] = new Wall();

		items[17][5] = new Wall();
		items[17][11] = new Wall();
		items[17][13] = new Wall();
		items[17][15] = new Wall();
		items[17][18] = new Wall();
		items[17][21] = new Wall();
		items[17][23] = new Wall();

		items[18][6] = new Wall();
		items[18][7] = new Wall();
		items[18][8] = new Wall();
		items[18][9] = new Wall();
		items[18][11] = new Wall();
		items[18][13] = new Wall();
		items[18][15] = new Wall();
		items[18][21] = new Wall();
		items[18][23] = new Wall();

		items[19][7] = new Wall();
		items[19][11] = new Wall();
		items[19][15] = new Wall();
		items[19][18] = new Wall();
		items[19][21] = new Wall();
		items[19][23] = new Wall();

		items[20][3] = new Wall();
		items[20][8] = new Wall();
		items[20][12] = new Wall();
		items[20][15] = new Wall();
		items[20][18] = new Wall();
		items[20][21] = new Wall();
		items[20][23] = new Wall();

		items[21][2] = new Wall();
		items[21][4] = new Wall();
		items[21][9] = new Wall();
		items[21][12] = new Wall();
		items[21][14] = new Wall();
		items[21][18] = new Wall();
		items[21][21] = new Wall();
		items[21][23] = new Wall();

		items[22][1] = new Wall();
		items[22][4] = new Wall();
		items[22][10] = new Wall();
		items[22][14] = new Wall();
		items[22][17] = new Wall();
		items[22][21] = new Wall();
		items[22][23] = new Wall();

		items[23][1] = new Wall();
		items[23][5] = new Wall();
		items[23][11] = new Wall();
		items[23][12] = new Wall();
		items[23][13] = new Wall();
		items[23][14] = new Wall();
		items[23][15] = new Wall();
		items[23][16] = new Wall();
		items[23][17] = new Wall();
		items[23][18] = new Wall();
		items[23][19] = new Wall();
		items[23][20] = new Wall();
		items[23][21] = new Wall();
		items[23][22] = new Wall();
		items[23][23] = new Wall();

		items[24][2] = new Wall();
		items[24][5] = new Wall();

		items[25][2] = new Wall();
		items[25][4] = new Wall();
		items[25][8] = new Wall();
		items[25][21] = new Wall();

		items[26][1] = new Wall();
		items[26][4] = new Wall();
		items[26][8] = new Wall();
		items[26][17] = new Wall();
		items[26][19] = new Wall();
		items[26][23] = new Wall();

		items[27][0] = new Wall();
		items[27][5] = new Wall();
		items[27][14] = new Wall();
		items[27][20] = new Wall();
		items[27][23] = new Wall();

		items[28][0] = new Wall();
		items[28][4] = new Wall();
		items[28][16] = new Wall();
		items[28][17] = new Wall();
		items[28][20] = new Wall();
		items[28][23] = new Wall();

		items[29][0] = new Wall();
		items[29][4] = new Wall();
		items[29][12] = new Wall();
		items[29][14] = new Wall();
		items[29][17] = new Wall();
		items[29][20] = new Wall();
		items[29][23] = new Wall();

		items[30][1] = new Wall();
		items[30][3] = new Wall();
		items[30][9] = new Wall();
		items[30][11] = new Wall();
		items[30][14] = new Wall();
		items[30][17] = new Wall();
		items[30][20] = new Wall();
		items[30][23] = new Wall();

		items[31][3] = new Wall();
		items[31][8] = new Wall();
		items[31][11] = new Wall();
		items[31][14] = new Wall();
		items[31][17] = new Wall();
		items[31][20] = new Wall();
		items[31][23] = new Wall();

		items[32][6] = new Wall();
		items[32][7] = new Wall();
		items[32][8] = new Wall();
		items[32][9] = new Wall();
		items[32][10] = new Wall();
		items[32][11] = new Wall();
		items[32][12] = new Wall();
		items[32][13] = new Wall();
		items[32][14] = new Wall();
		items[32][15] = new Wall();
		items[32][16] = new Wall();
		items[32][17] = new Wall();
		items[32][18] = new Wall();
		items[32][19] = new Wall();
		items[32][20] = new Wall();
		items[32][21] = new Wall();
		items[32][22] = new Wall();
		items[32][23] = new Wall();

		items[33][8] = new Wall();
		items[33][12] = new Wall();
		items[33][16] = new Wall();
		items[33][20] = new Wall();

		items[34][6] = new Wall();
		items[34][10] = new Wall();
		items[34][14] = new Wall();
		items[34][18] = new Wall();
		items[34][22] = new Wall();

		// place trees

		items[2][6] = new Tree();
		items[2][14] = new Tree();
		items[2][22] = new Tree();
		items[8][13] = new Tree();
		items[28][5] = new Tree();
		items[29][5] = new Tree();

		// place watertaps

		items[6][3] = new WaterTap();
		items[6][11] = new WaterTap();
		items[6][19] = new WaterTap();
		items[17][8] = new WaterTap();
		items[22][16] = new WaterTap();
		items[22][19] = new WaterTap();
		items[23][2] = new WaterTap();
		items[31][9] = new WaterTap();
		items[31][12] = new WaterTap();
		items[31][15] = new WaterTap();
		items[31][18] = new WaterTap();
		items[31][21] = new WaterTap();

		// assign a cell filter to the level
		this.cellFilter = new WaterFilter(12);

		// place doors and keys

		items[13][3] = new Key();
		items[17][6] = new Key();
		items[11][22] = new Door();
		items[17][22] = new Door();

		// place dustbins

		items[22][22] = new DustbinPaper();
		items[20][22] = new DustbinMetal();
		items[10][4] = new DustbinMetal();
		items[21][22] = new DustbinGlass();
		items[18][22] = new DustbinRest();
		items[34][23] = new DustbinRest();
		items[19][22] = new DustbinBio();
		items[25][5] = new DustbinBio();

		// place waste

		for (int i = 0; i < 4; i++) {
			Position pos = this.getFreeCell(items);
			items[pos.getCol()][pos.getRow()] = new WastePaper();
			this.numberOfWaste++;
		}

		for (int i = 0; i < 4; i++) {
			Position pos = this.getFreeCell(items);
			items[pos.getCol()][pos.getRow()] = new WasteMetal();
			this.numberOfWaste++;
		}

		for (int i = 0; i < 4; i++) {
			Position pos = this.getFreeCell(items);
			items[pos.getCol()][pos.getRow()] = new WasteGlass();
			this.numberOfWaste++;
		}

		for (int i = 0; i < 4; i++) {
			Position pos = this.getFreeCell(items);
			items[pos.getCol()][pos.getRow()] = new WasteRest();
			this.numberOfWaste++;
		}

		for (int i = 0; i < 4; i++) {
			Position pos = this.getFreeCell(items);
			items[pos.getCol()][pos.getRow()] = new WasteBio();
			this.numberOfWaste++;
		}

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see Level#getSeconds()
	 */
	@Override
	public int getSeconds() {
		return 210;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see Level#drawHelp(greenfoot.GreenfootImage)
	 */
	@Override
	public void drawHelp(GreenfootImage image) {
		image.drawString("Level 5 (waste and water): ", 20, 50);
		image.drawString("Task: Find, collect and dispose of the waste!", 20,
				100);
		image.drawString("Additional task:", 20, 150);
		image.drawString("Somebody left the water running!", 20, 200);
		image.drawString("Find the taps and turn them off!", 20, 250);
	}

}
