import greenfoot.GreenfootImage;

/**
 * representation of level 6 (waste and radioactivity)
 * 
 * Task: Find, collect and dispose of the waste!
 * 
 * Additional task: Nuclear power is a dangerous energy source! Find
 * the nuclear power stations, exchange them with wind turbines and prevent
 * radioactive waste and radioactive contamination!
 * 
 * Notice: this level contains pitfalls, ladders/bridges and radioactivity
 * 
 * @author Dietrich Boles (University of Oldenburg, Germany)
 * @version 01.12.2009
 */
public class Level6 extends Level {

	public Level6() {
		super("level6.png", new SelectionItem(6, "level6selection.png"));
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see Level#createLevel(Item[][])
	 */
	@Override
	public void createLevel(Item[][] items) {
		this.numberOfWaste = 0;
		this.cellFilter = null; // no cell filter
		this.worldFilter = null; // no world filter

		// empty all cells
		for (int c = 0; c < items.length; c++) {
			for (int r = 0; r < items[c].length; r++) {
				items[c][r] = null;
			}
		}

		// place walls

		items[0][15] = new Wall();
		items[0][16] = new Wall();
		items[0][17] = new Wall();
		items[0][20] = new Wall();

		items[1][17] = new Wall();
		items[1][20] = new Wall();

		items[2][7] = new Wall();
		items[2][10] = new Wall();
		items[2][20] = new Wall();

		items[3][7] = new Wall();
		items[3][10] = new Wall();
		items[3][11] = new Wall();
		items[3][12] = new Wall();
		items[3][13] = new Wall();
		items[3][14] = new Wall();
		items[3][20] = new Wall();
		items[3][21] = new Wall();

		items[4][0] = new Wall();
		items[4][1] = new Wall();
		items[4][2] = new Wall();
		items[4][7] = new Wall();
		items[4][21] = new Wall();

		items[5][2] = new Wall();
		items[5][3] = new Wall();
		items[5][4] = new Wall();
		items[5][18] = new Wall();
		items[5][19] = new Wall();
		items[5][20] = new Wall();
		items[5][21] = new Wall();

		items[6][4] = new Wall();
		items[6][5] = new Wall();
		items[6][11] = new Wall();
		items[6][12] = new Wall();
		items[6][21] = new Wall();

		items[7][0] = new Wall();
		items[7][4] = new Wall();
		items[7][10] = new Wall();
		items[7][13] = new Wall();
		items[7][21] = new Wall();

		items[8][0] = new Wall();
		items[8][4] = new Wall();
		items[8][9] = new Wall();
		items[8][14] = new Wall();
		items[8][17] = new Wall();
		items[8][20] = new Wall();
		items[8][21] = new Wall();

		items[9][3] = new Wall();
		items[9][4] = new Wall();
		items[9][8] = new Wall();
		items[9][11] = new Wall();
		items[9][14] = new Wall();
		items[9][17] = new Wall();
		items[9][20] = new Wall();

		items[10][3] = new Wall();
		items[10][8] = new Wall();
		items[10][11] = new Wall();
		items[10][14] = new Wall();
		items[10][20] = new Wall();
		items[10][21] = new Wall();
		items[10][22] = new Wall();

		items[11][0] = new Wall();
		items[11][2] = new Wall();
		items[11][3] = new Wall();
		items[11][8] = new Wall();
		items[11][14] = new Wall();

		items[12][13] = new Wall();

		items[13][9] = new Wall();
		items[13][10] = new Wall();
		items[13][11] = new Wall();
		items[13][12] = new Wall();
		items[13][17] = new Wall();

		items[14][17] = new Wall();

		items[15][2] = new Wall();

		items[16][0] = new Wall();
		items[16][2] = new Wall();
		items[16][6] = new Wall();
		items[16][23] = new Wall();
		items[16][24] = new Wall();

		items[17][2] = new Wall();
		items[17][6] = new Wall();
		items[17][11] = new Wall();
		items[17][12] = new Wall();
		items[17][13] = new Wall();
		items[17][14] = new Wall();
		items[17][19] = new Wall();

		items[18][2] = new Wall();
		items[18][14] = new Wall();

		items[19][1] = new Wall();
		items[19][2] = new Wall();
		items[19][14] = new Wall();
		items[19][15] = new Wall();
		items[19][16] = new Wall();

		items[20][2] = new Wall();
		items[20][15] = new Wall();

		items[21][15] = new Wall();
		items[21][19] = new Wall();
		items[21][20] = new Wall();

		items[22][15] = new Wall();
		items[22][20] = new Wall();
		items[22][21] = new Wall();

		items[23][6] = new Wall();

		items[24][6] = new Wall();
		items[24][10] = new Wall();
		items[24][11] = new Wall();
		items[24][12] = new Wall();

		items[26][0] = new Wall();
		items[26][2] = new Wall();
		items[26][20] = new Wall();
		items[26][21] = new Wall();

		items[27][2] = new Wall();
		items[27][13] = new Wall();
		items[27][14] = new Wall();
		items[27][15] = new Wall();
		items[27][16] = new Wall();
		items[27][17] = new Wall();
		items[27][18] = new Wall();
		items[27][21] = new Wall();

		items[28][2] = new Wall();
		items[28][13] = new Wall();
		items[28][18] = new Wall();

		items[29][2] = new Wall();
		items[29][6] = new Wall();
		items[29][7] = new Wall();
		items[29][8] = new Wall();
		items[29][13] = new Wall();
		items[29][18] = new Wall();

		items[30][3] = new Wall();
		items[30][6] = new Wall();
		items[30][8] = new Wall();
		items[30][13] = new Wall();

		items[31][4] = new Wall();
		items[31][6] = new Wall();
		items[31][8] = new Wall();
		items[31][10] = new Wall();
		items[31][11] = new Wall();
		items[31][12] = new Wall();
		items[31][13] = new Wall();
		items[31][18] = new Wall();
		items[31][22] = new Wall();

		items[32][5] = new Wall();
		items[32][6] = new Wall();
		items[32][8] = new Wall();
		items[32][9] = new Wall();
		items[32][14] = new Wall();
		items[32][18] = new Wall();
		items[32][22] = new Wall();

		items[33][3] = new Wall();
		items[33][12] = new Wall();

		items[34][7] = new Wall();
		items[34][16] = new Wall();
		items[34][18] = new Wall();

		// place trees

		items[4][2] = new Tree();
		items[3][15] = new Tree();
		items[4][22] = new Tree();
		items[5][22] = new Tree();
		items[17][15] = new Tree();
		items[18][15] = new Tree();
		items[28][14] = new Tree();
		items[29][14] = new Tree();
		items[31][19] = new Tree();
		items[32][19] = new Tree();
		items[28][3] = new Tree();
		items[29][3] = new Tree();

		// place one-way-signs

		items[26][1] = new OneWay(false);

		// place nuclear power stations

		items[2][21] = new Nuclear();
		items[7][5] = new Nuclear();
		items[9][12] = new Nuclear();
		items[9][21] = new Nuclear();
		items[21][16] = new Nuclear();
		items[21][21] = new Nuclear();
		items[23][7] = new Nuclear();
		items[30][7] = new Nuclear();
		items[32][23] = new Nuclear();

		// place pitfalls and ladders/bridges

		items[11][1] = new Pitfall();
		items[30][18] = new Pitfall();
		items[33][18] = new Pitfall();
		items[16][19] = new Pitfall();
		items[16][20] = new Pitfall();
		items[16][21] = new Pitfall();
		items[16][22] = new Pitfall();
		items[18][19] = new Pitfall();
		items[19][19] = new Pitfall();
		items[20][19] = new Pitfall();
		items[22][19] = new Pitfall();
		items[22][22] = new Pitfall();
		items[22][23] = new Pitfall();
		items[22][24] = new Pitfall();
		items[21][5] = new Pitfall();
		items[21][6] = new Pitfall();
		items[21][7] = new Pitfall();
		items[21][8] = new Pitfall();
		items[21][9] = new Pitfall();
		items[22][5] = new Pitfall();
		items[22][9] = new Pitfall();
		items[23][5] = new Pitfall();
		items[23][9] = new Pitfall();
		items[24][5] = new Pitfall();
		items[24][9] = new Pitfall();
		items[25][5] = new Pitfall();
		items[25][9] = new Pitfall();
		items[25][6] = new Pitfall();
		items[25][7] = new Pitfall();
		items[25][8] = new Pitfall();

		items[6][22] = new Ladder();
		items[10][0] = new Ladder();
		items[15][0] = new Ladder();
		items[17][24] = new Ladder();
		items[24][8] = new Ladder();

		// place dustbins

		items[9][9] = new DustbinPaper();
		items[34][17] = new DustbinMetal();
		items[0][21] = new DustbinGlass();
		items[7][1] = new DustbinRest();
		items[32][7] = new DustbinBio();

		// place waste

		for (int i = 0; i < 4; i++) {
			Position pos = this.getFreeCell(items);
			items[pos.getCol()][pos.getRow()] = new WastePaper();
			this.numberOfWaste++;
		}

		for (int i = 0; i < 4; i++) {
			Position pos = this.getFreeCell(items);
			items[pos.getCol()][pos.getRow()] = new WasteMetal();
			this.numberOfWaste++;
		}

		for (int i = 0; i < 4; i++) {
			Position pos = this.getFreeCell(items);
			items[pos.getCol()][pos.getRow()] = new WasteGlass();
			this.numberOfWaste++;
		}

		for (int i = 0; i < 4; i++) {
			Position pos = this.getFreeCell(items);
			items[pos.getCol()][pos.getRow()] = new WasteRest();
			this.numberOfWaste++;
		}

		for (int i = 0; i < 4; i++) {
			Position pos = this.getFreeCell(items);
			items[pos.getCol()][pos.getRow()] = new WasteBio();
			this.numberOfWaste++;
		}

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see Level#getSeconds()
	 */
	@Override
	public int getSeconds() {
		return 200;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see Level#drawHelp(greenfoot.GreenfootImage)
	 */
	@Override
	public void drawHelp(GreenfootImage image) {
		image.drawString("Level 6 (waste and radioactivity): ", 20, 50);
		image.drawString("Task: Find, collect and dispose of the waste!", 20,
				100);
		image.drawString("Additional task:", 20, 150);
		image.drawString(
				"Nuclear power is a dangerous energy source!", 20,
				200);
		image.drawString("Find the nuclear power stations,", 20, 250);
		image.drawString("exchange them with wind turbines", 20, 300);
		image.drawString(
				"and prevent radioactive waste and radioactive contamination!",
				20, 350);
	}

}
