import greenfoot.GreenfootImage;

/**
 * representation of level 8 (waste and coal)
 * 
 * Task: Find, collect and dispose of the waste!
 * 
 * Additional task: Coal-burning power plants are responsible for a large
 * fraction of carbon dioxide (CO2) emissions worldwide. Find the coal-burning
 * power plants, exchange them with solar collectors and reduce global warming.
 * 
 * Notice: this level contains pitfalls and mines.
 * 
 * @author Dietrich Boles (University of Oldenburg, Germany)
 * @version 01.12.2009
 */
public class Level8 extends Level {

	public Level8() {
		super("level8.png", new SelectionItem(8, "level8selection.png"));
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see Level#createLevel(Item[][])
	 */
	@Override
	public void createLevel(Item[][] items) {
		this.numberOfWaste = 0;
		this.cellFilter = null;
		this.globalFilter = new DarknessFilter(); // darkness

		// empty all cells
		for (int c = 0; c < items.length; c++) {
			for (int r = 0; r < items[c].length; r++) {
				items[c][r] = null;
			}
		}

		// place walls

		items[0][3] = new Wall();
		items[0][7] = new Wall();
		items[0][10] = new Wall();
		items[0][14] = new Wall();
		items[0][19] = new Wall();

		items[1][7] = new Wall();
		items[1][14] = new Wall();
		items[1][24] = new Wall();

		items[2][6] = new Wall();
		items[2][7] = new Wall();
		items[2][8] = new Wall();
		items[2][12] = new Wall();
		items[2][13] = new Wall();
		items[2][14] = new Wall();
		items[2][21] = new Wall();
		items[2][22] = new Wall();

		items[3][0] = new Wall();
		items[3][1] = new Wall();
		items[3][8] = new Wall();
		items[3][12] = new Wall();
		items[3][22] = new Wall();

		items[4][1] = new Wall();
		items[4][2] = new Wall();
		items[4][3] = new Wall();
		items[4][4] = new Wall();
		items[4][6] = new Wall();
		items[4][8] = new Wall();
		items[4][9] = new Wall();
		items[4][16] = new Wall();
		items[4][17] = new Wall();
		items[4][18] = new Wall();

		items[5][4] = new Wall();
		items[5][5] = new Wall();
		items[5][6] = new Wall();
		items[5][9] = new Wall();
		items[5][19] = new Wall();

		items[6][6] = new Wall();
		items[6][10] = new Wall();
		items[6][11] = new Wall();
		items[6][12] = new Wall();
		items[6][20] = new Wall();

		items[7][6] = new Wall();
		items[7][12] = new Wall();
		items[7][20] = new Wall();

		items[8][8] = new Wall();
		items[8][12] = new Wall();
		items[8][13] = new Wall();
		items[8][14] = new Wall();
		items[8][15] = new Wall();
		items[8][16] = new Wall();
		items[8][17] = new Wall();
		items[8][18] = new Wall();
		items[8][19] = new Wall();

		items[9][8] = new Wall();
		items[9][23] = new Wall();

		items[10][6] = new Wall();
		items[10][14] = new Wall();
		items[10][15] = new Wall();
		items[10][16] = new Wall();
		items[10][18] = new Wall();
		items[10][19] = new Wall();
		items[10][23] = new Wall();

		items[11][6] = new Wall();
		items[11][14] = new Wall();
		items[11][18] = new Wall();

		items[12][4] = new Wall();
		items[12][5] = new Wall();
		items[12][9] = new Wall();
		items[12][10] = new Wall();
		items[12][11] = new Wall();
		items[12][14] = new Wall();
		items[12][15] = new Wall();
		items[12][16] = new Wall();
		items[12][18] = new Wall();
		items[12][22] = new Wall();
		items[12][24] = new Wall();

		items[13][4] = new Wall();
		items[13][9] = new Wall();
		items[13][10] = new Wall();
		items[13][15] = new Wall();
		items[13][16] = new Wall();
		items[13][18] = new Wall();
		items[13][22] = new Wall();
		items[13][24] = new Wall();

		items[14][0] = new Wall();
		items[14][1] = new Wall();
		items[14][3] = new Wall();
		items[14][4] = new Wall();
		items[14][7] = new Wall();
		items[14][15] = new Wall();
		items[14][22] = new Wall();

		items[15][3] = new Wall();
		items[15][5] = new Wall();
		items[15][15] = new Wall();
		items[15][22] = new Wall();
		items[15][23] = new Wall();

		items[16][2] = new Wall();
		items[16][5] = new Wall();
		items[16][9] = new Wall();
		items[16][14] = new Wall();
		items[16][15] = new Wall();
		items[16][22] = new Wall();

		items[17][1] = new Wall();
		items[17][6] = new Wall();
		items[17][13] = new Wall();
		items[17][16] = new Wall();
		items[17][17] = new Wall();
		items[17][21] = new Wall();
		items[17][22] = new Wall();
		items[17][24] = new Wall();

		items[18][2] = new Wall();
		items[18][7] = new Wall();
		items[18][12] = new Wall();
		items[18][18] = new Wall();
		items[18][19] = new Wall();
		items[18][20] = new Wall();

		items[19][0] = new Wall();
		items[19][2] = new Wall();
		items[19][7] = new Wall();
		items[19][10] = new Wall();
		items[19][11] = new Wall();
		items[19][12] = new Wall();
		items[19][20] = new Wall();
		items[19][22] = new Wall();

		items[20][4] = new Wall();
		items[20][5] = new Wall();
		items[20][9] = new Wall();
		items[20][10] = new Wall();
		items[20][12] = new Wall();
		items[20][20] = new Wall();
		items[20][22] = new Wall();
		items[20][24] = new Wall();

		items[21][7] = new Wall();
		items[21][12] = new Wall();
		items[21][15] = new Wall();
		items[21][20] = new Wall();
		items[21][21] = new Wall();
		items[21][22] = new Wall();
		items[21][24] = new Wall();

		items[22][2] = new Wall();
		items[22][6] = new Wall();
		items[22][8] = new Wall();
		items[22][10] = new Wall();
		items[22][11] = new Wall();
		items[22][12] = new Wall();
		items[22][15] = new Wall();

		items[23][2] = new Wall();
		items[23][6] = new Wall();
		items[23][15] = new Wall();
		items[23][16] = new Wall();
		items[23][17] = new Wall();

		items[24][6] = new Wall();
		items[24][11] = new Wall();
		items[24][12] = new Wall();
		items[24][17] = new Wall();
		items[24][20] = new Wall();
		items[24][21] = new Wall();

		items[25][4] = new Wall();
		items[25][5] = new Wall();
		items[25][6] = new Wall();
		items[25][7] = new Wall();
		items[25][10] = new Wall();
		items[25][11] = new Wall();
		items[25][12] = new Wall();
		items[25][21] = new Wall();

		items[26][4] = new Wall();
		items[26][7] = new Wall();
		items[26][10] = new Wall();
		items[26][14] = new Wall();

		items[27][2] = new Wall();
		items[27][3] = new Wall();

		items[28][0] = new Wall();
		items[28][1] = new Wall();
		items[28][12] = new Wall();

		items[29][3] = new Wall();
		items[29][4] = new Wall();
		items[29][11] = new Wall();
		items[29][17] = new Wall();
		items[29][18] = new Wall();
		items[29][19] = new Wall();
		items[29][22] = new Wall();

		items[30][5] = new Wall();
		items[30][7] = new Wall();
		items[30][11] = new Wall();
		items[30][17] = new Wall();
		items[30][20] = new Wall();
		items[30][21] = new Wall();

		items[31][0] = new Wall();
		items[31][4] = new Wall();
		items[31][5] = new Wall();
		items[31][6] = new Wall();
		items[31][7] = new Wall();
		items[31][8] = new Wall();
		items[31][9] = new Wall();
		items[31][10] = new Wall();
		items[31][11] = new Wall();
		items[31][12] = new Wall();
		items[31][15] = new Wall();
		items[31][16] = new Wall();
		items[31][17] = new Wall();

		items[32][0] = new Wall();
		items[32][5] = new Wall();
		items[32][8] = new Wall();
		items[32][13] = new Wall();
		items[32][14] = new Wall();

		items[33][0] = new Wall();
		items[33][7] = new Wall();
		items[33][8] = new Wall();
		items[33][9] = new Wall();
		items[33][11] = new Wall();

		items[34][5] = new Wall();
		items[34][11] = new Wall();
		items[34][12] = new Wall();
		items[34][13] = new Wall();
		items[34][14] = new Wall();

		// place mines

		items[4][7] = new Mine();

		items[5][7] = new Mine();
		items[5][8] = new Mine();

		items[6][7] = new Mine();
		items[6][8] = new Mine();
		items[6][9] = new Mine();

		items[7][7] = new Mine();
		items[7][8] = new Mine();
		items[7][9] = new Mine();
		items[7][10] = new Mine();
		items[7][11] = new Mine();

		items[8][7] = new Mine();
		items[8][9] = new Mine();
		items[8][10] = new Mine();
		items[8][11] = new Mine();

		items[9][7] = new Mine();
		items[9][9] = new Mine();
		items[9][10] = new Mine();
		items[9][11] = new Mine();
		items[9][12] = new Mine();
		items[9][13] = new Mine();
		items[9][14] = new Mine();
		items[9][15] = new Mine();
		items[9][16] = new Mine();
		items[9][17] = new Mine();
		items[9][18] = new Mine();

		items[10][7] = new Mine();
		items[10][8] = new Mine();
		items[10][9] = new Mine();
		items[10][10] = new Mine();
		items[10][11] = new Mine();
		items[10][12] = new Mine();
		items[10][13] = new Mine();
		items[10][17] = new Mine();

		items[11][7] = new Mine();
		items[11][8] = new Mine();
		items[11][9] = new Mine();
		items[11][10] = new Mine();
		items[11][11] = new Mine();
		items[11][12] = new Mine();
		items[11][13] = new Mine();
		items[11][15] = new Mine();
		items[11][16] = new Mine();
		items[11][17] = new Mine();

		items[12][6] = new Mine();
		items[12][7] = new Mine();
		items[12][8] = new Mine();
		items[12][12] = new Mine();
		items[12][13] = new Mine();
		items[12][17] = new Mine();

		items[13][5] = new Mine();
		items[13][6] = new Mine();
		items[13][7] = new Mine();
		items[13][8] = new Mine();
		items[13][11] = new Mine();
		items[13][12] = new Mine();
		items[13][13] = new Mine();
		items[13][14] = new Mine();
		items[13][23] = new Mine();

		items[14][5] = new Mine();
		items[14][6] = new Mine();
		items[14][8] = new Mine();
		items[14][9] = new Mine();
		items[14][10] = new Mine();
		items[14][11] = new Mine();
		items[14][12] = new Mine();
		items[14][13] = new Mine();
		items[14][14] = new Mine();
		items[14][23] = new Mine();
		items[14][24] = new Mine();

		items[15][0] = new Mine();
		items[15][1] = new Mine();
		items[15][2] = new Mine();
		items[15][6] = new Mine();
		items[15][7] = new Mine();
		items[15][8] = new Mine();
		items[15][9] = new Mine();
		items[15][10] = new Mine();
		items[15][11] = new Mine();
		items[15][12] = new Mine();
		items[15][13] = new Mine();
		items[15][14] = new Mine();
		items[15][24] = new Mine();

		items[16][0] = new Mine();
		items[16][1] = new Mine();
		items[16][6] = new Mine();
		items[16][7] = new Mine();
		items[16][8] = new Mine();
		items[16][10] = new Mine();
		items[16][11] = new Mine();
		items[16][12] = new Mine();
		items[16][13] = new Mine();
		items[16][23] = new Mine();
		items[16][24] = new Mine();

		items[17][0] = new Mine();
		items[17][7] = new Mine();
		items[17][8] = new Mine();
		items[17][9] = new Mine();
		items[17][10] = new Mine();
		items[17][11] = new Mine();
		items[17][12] = new Mine();
		items[17][23] = new Mine();

		items[18][0] = new Mine();
		items[18][1] = new Mine();
		items[18][8] = new Mine();
		items[18][9] = new Mine();
		items[18][10] = new Mine();
		items[18][11] = new Mine();
		items[18][23] = new Mine();
		items[18][24] = new Mine();

		items[19][8] = new Mine();
		items[19][9] = new Mine();
		items[19][23] = new Mine();
		items[19][24] = new Mine();

		items[20][8] = new Mine();
		items[20][23] = new Mine();

		items[21][8] = new Mine();
		items[21][9] = new Mine();
		items[21][23] = new Mine();
		items[23][23] = new Pitfall();

		items[22][7] = new Mine();
		items[22][9] = new Mine();

		items[23][7] = new Mine();
		items[23][8] = new Mine();
		items[23][9] = new Mine();
		items[23][10] = new Mine();
		items[23][11] = new Mine();

		items[24][7] = new Mine();
		items[24][8] = new Mine();
		items[24][9] = new Mine();
		items[24][10] = new Mine();

		items[25][8] = new Mine();
		items[25][9] = new Mine();

		items[32][6] = new Mine();
		items[32][7] = new Mine();
		items[32][9] = new Mine();
		items[32][10] = new Mine();
		items[32][11] = new Mine();
		items[32][12] = new Mine();

		items[33][6] = new Mine();
		items[33][10] = new Mine();
		items[33][12] = new Mine();
		items[33][13] = new Mine();

		items[34][6] = new Mine();
		items[34][7] = new Mine();
		items[34][8] = new Mine();
		items[34][9] = new Mine();
		items[34][10] = new Mine();
		items[34][11] = new Mine();

		// place trees

		items[3][2] = new Tree();
		items[7][0] = new Tree();
		items[8][0] = new Tree();
		items[9][0] = new Tree();
		items[26][15] = new Tree();
		items[21][16] = new Tree();
		items[22][16] = new Tree();
		items[33][1] = new Tree();
		items[0][15] = new Tree();
		items[1][15] = new Tree();
		items[2][15] = new Tree();

		// place coal-burning power plants

		items[0][4] = new Coal();
		items[0][8] = new Coal();
		items[3][24] = new Coal();
		items[7][3] = new Coal();
		items[11][19] = new Coal();
		items[16][16] = new Coal();
		items[20][11] = new Coal();
		items[30][0] = new Coal();
		items[30][12] = new Coal();
		items[30][22] = new Coal();
		this.worldFilter = new SmogFilter(10);

		// place dustbins

		items[23][3] = new DustbinPaper();
		items[33][20] = new DustbinMetal();
		items[0][11] = new DustbinGlass();
		items[20][21] = new DustbinRest();
		items[32][1] = new DustbinBio();

		// place waste

		for (int i = 0; i < 4; i++) {
			Position pos = this.getFreeCell(items);
			items[pos.getCol()][pos.getRow()] = new WastePaper();
			this.numberOfWaste++;
		}

		for (int i = 0; i < 4; i++) {
			Position pos = this.getFreeCell(items);
			items[pos.getCol()][pos.getRow()] = new WasteMetal();
			this.numberOfWaste++;
		}

		for (int i = 0; i < 4; i++) {
			Position pos = this.getFreeCell(items);
			items[pos.getCol()][pos.getRow()] = new WasteGlass();
			this.numberOfWaste++;
		}

		for (int i = 0; i < 3; i++) {
			Position pos = this.getFreeCell(items);
			items[pos.getCol()][pos.getRow()] = new WasteRest();
			this.numberOfWaste++;
		}

		for (int i = 0; i < 4; i++) {
			Position pos = this.getFreeCell(items);
			items[pos.getCol()][pos.getRow()] = new WasteBio();
			this.numberOfWaste++;
		}

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see Level#getSeconds()
	 */
	@Override
	public int getSeconds() {
		return 220;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see Level#drawHelp(greenfoot.GreenfootImage)
	 */
	@Override
	public void drawHelp(GreenfootImage image) {
		image.drawString("Level 8 (waste and CO2-emissions): ", 20, 50);
		image.drawString("Task: Find, collect and dispose of the waste!", 20,
				100);
		image.drawString("Additional task:", 20, 150);
		image.drawString(
				"Coal-burning power plants are responsible for a large", 20,
				200);
		image.drawString(
				"fraction of carbon dioxide (CO2) emissions worldwide.", 20,
				250);
		image.drawString(
				"Find the coal-burning power plants, exchange them with", 20,
				300);
		image
				.drawString("solar collectors and reduce global warming!", 20,
						350);
	}

}
