import greenfoot.GreenfootImage;

/**
 * Representation of a mine
 * 
 * @author Dietrich Boles (University of Oldenburg, Germany)
 * @version 01.12.2009
 */
public class Mine extends Item {

	// shared by all objects
	private static GreenfootImage img = new GreenfootImage("mine.png");

	public Mine() {
		super();
		this.setImage(Mine.img);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see Item#isAccessible(WasteWorld, int, int)
	 */
	@Override
	public boolean isAccessible(WasteWorld world, int col, int row) {
		return true;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see Item#draw(greenfoot.GreenfootImage, int, int, int)
	 */
	@Override
	public void draw(GreenfootImage img, int c, int r, int cellSize) {
		img.drawImage(this.getImage(), (c + 1) * cellSize, (r + 1) * cellSize);
	}
	
	/* (non-Javadoc)
	 * @see Item#handleCollision(WasteWorld, int, int)
	 */
	@Override
	public void handleCollision(WasteWorld world, int col, int row) {
		world.getLevel().getGlobalFilter().setMax();
	}


	/* (non-Javadoc)
	 * @see Item#handleCollisionBeforeMove(WasteWorld, int, int)
	 */
	@Override
	public void handleCollisionBeforeMove(WasteWorld world, int col, int row) {
		world.getLevel().getGlobalFilter().setMin();
	}

}
