import greenfoot.GreenfootImage;

/**
 * Representation of a new tree. A new tree can replace a stump.
 * 
 * @author Dietrich Boles (University of Oldenburg, Germany)
 * @version 01.12.2009
 */
public class NewTree extends Item {

	// shared by all objects
	private static GreenfootImage img = new GreenfootImage("newtree.png");

	public NewTree() {
		super(Item.STUMP_TREE);
		this.setImage(NewTree.img);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see Item#isAccessible(WasteWorld, int, int)
	 */
	@Override
	public boolean isAccessible(WasteWorld world, int col, int row) {
		return true;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see Item#draw(greenfoot.GreenfootImage, int, int, int)
	 */
	@Override
	public void draw(GreenfootImage img, int c, int r, int cellSize) {
		img.drawImage(this.getImage(), (c + 1) * cellSize, r * cellSize);
	}

}
