import greenfoot.Actor;
import greenfoot.GreenfootImage;

import java.awt.Color;
import java.awt.Font;

/**
 * representation of the rest notice (singleton pattern)
 * 
 * @author Dietrich Boles (University of Oldenburg, Germany)
 * @version 01.12.2009
 */
public class Rest extends Actor {
	private int number;

	private static Rest rest = new Rest();

	public static Rest getRest() {
		return Rest.rest;
	}

	private GreenfootImage image, restImage;

	private Rest() { // singleton
		this.number = 0;
		this.restImage = new GreenfootImage("rest.png");
		this.image = new GreenfootImage("rest.png");
		this.image.setTransparency(200);
		this.image.setColor(Color.black);
		this.image.setFont(new Font("Monospaced", Font.BOLD, 36));
		this.updateImage();
		this.setImage(this.image);
	}

	public void setRest(int n) {
		this.number = n;
		this.updateImage();
	}

	public void incrRest(int n) {
		this.number += n;
		this.updateImage();
	}

	public void decrRest(int n) {
		this.number -= n;
		this.updateImage();
	}

	public int getRestNumber() {
		return this.number;
	}

	private void updateImage() {
		this.image.clear();
		this.image.drawImage(this.restImage, 0, 0);
		String str = "" + this.number;
		int slen = Metrics.stringWidth(str, this.image.getFont());
		this.image.drawString(str, 20 + this.image.getWidth() / 2 - slen / 2,
				35);
	}
}
