import greenfoot.GreenfootImage;

/**
 * Representation of a solar collector. By entering a coal-fired power station
 * it will be replaced by a solar collector.
 * 
 * @author Dietrich Boles (University of Oldenburg, Germany)
 * @version 01.12.2009
 */
public class Solar extends Item {

	// shared by all objects
	private static GreenfootImage img = new GreenfootImage("solar.png");

	public Solar() {
		super(Item.COAL_SOLAR);
		this.setImage(Solar.img);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see Item#isAccessible(WasteWorld, int, int)
	 */
	@Override
	public boolean isAccessible(WasteWorld world, int col, int row) {
		return true;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see Item#draw(greenfoot.GreenfootImage, int, int, int)
	 */
	@Override
	public void draw(GreenfootImage img, int c, int r, int cellSize) {
		img.drawImage(this.getImage(), (c + 1) * cellSize, r * cellSize);
	}

}
