import greenfoot.GreenfootImage;

/**
 * Representation of a wall. A wall cannot be entered by the boy.
 * 
 * @author Dietrich Boles (University of Oldenburg, Germany)
 * @version 01.12.2009
 */
public class Wall extends Item {

	// shared by all objects
	private static GreenfootImage img = new GreenfootImage("wall.png");

	public Wall() {
		this.setImage(Wall.img);

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see Item#isAccessible(WasteWorld, int, int)
	 */
	public boolean isAccessible(WasteWorld world, int col, int row) {
		return false; // cannot be entered by the boy
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see Item#draw(greenfoot.GreenfootImage, int, int, int)
	 */
	public void draw(GreenfootImage img, int c, int r, int cellSize) {
		img.drawImage(this.getImage(), (c + 1) * cellSize, (r + 1) * cellSize);
	}
}
