import greenfoot.GreenfootImage;

/**
 * representation of a piece of waste
 * 
 * @author Dietrich Boles (University of Oldenburg, Germany)
 * @version 01.12.2009
 */
public abstract class Waste extends Item {

	public Waste(int type) {
		super(type);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see Item#isAccessible(WasteWorld, int, int)
	 */
	@Override
	public boolean isAccessible(WasteWorld world, int col, int row) {
		return true; // can be entered by the boy
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see Item#draw(greenfoot.GreenfootImage, int, int, int)
	 */
	@Override
	public void draw(GreenfootImage img, int c, int r, int cellSize) {
		img.drawImage(this.getImage(), (c + 1) * cellSize, (r + 1) * cellSize);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see Item#handleCollisionAfterScrolling(WasteWorld, int, int)
	 */
	@Override
	public void handleCollisionAfterScrolling(WasteWorld world, int col, int row) {
		if (!Storage.getStorage().isFull()) {
			Sounds.pickup();
			Storage.getStorage().addItem(this); // add the waste to the storage
			Rest.getRest().decrRest(1);
			world.removeItem(col, row); // remove it from the world
		}
	}
}
