import greenfoot.GreenfootImage;

/**
 * Representation of a windmill. By entering a nuclear power station it will be
 * replaced by a windmill.
 * 
 * @author Dietrich Boles (University of Oldenburg, Germany)
 * @version 01.12.2009
 */
public class Windmill extends Item {

	// shared by all objects
	private static GreenfootImage img = new GreenfootImage("windmill.png");

	public Windmill() {
		super(Item.NUCLEAR_WIND);
		this.setImage(Windmill.img);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see Item#isAccessible(WasteWorld, int, int)
	 */
	@Override
	public boolean isAccessible(WasteWorld world, int col, int row) {
		return true;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see Item#draw(greenfoot.GreenfootImage, int, int, int)
	 */
	@Override
	public void draw(GreenfootImage img, int c, int r, int cellSize) {
		img.drawImage(this.getImage(), (c + 1) * cellSize, r * cellSize);
	}

}
